<?php
namespace ACL\Helpers\Instances;

use Doctrine\ORM\EntityManager;
use Exception;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use ACL\Helpers\Instances\Service as InstanceService;
use ACL\Helpers\Instances\Repository as InstanceRepository;
use Zeedhi\Framework\Session\Session;

class InstanceProvider {

    public static function getService()
    {
        return InstanceService::getInstance();
    }

    public static function getRepository()
    {
        return InstanceRepository::getInstance();
    }

    /** @return \ACL\Util\AclEnvironment  */
    public static function getEnvironment()
    {
        return InstanceManager::getInstance()->getService('acl_environment');
    }

    /** @return \Doctrine\ORM\EntityManager */
    public static function getEntityManager()
    {
        return InstanceManager::getInstance()->getService('entityManager');
    }

    /** @return \Teknisa\Libs\Util\NewCode */
    public static function getNewCode()
    {
        return InstanceManager::getInstance()->getService('newCodeSC');
    }

    /**
     * @return \Teknisa\Libs\Util\Environment
     * @throws Exception
     */
    public static function getLibEnvironment()
    {
        return InstanceManager::getInstance()->getService('libEnvironment');
    }

    public static function getLibConnectionCustom()
    {
        return InstanceManager::getInstance()->getService('connectionCustom');
    }

    /**
     * @return \Teknisa\Libs\Util\Utilities
     * @throws Exception
     */
    public static function getLibUtilities(): \Teknisa\Libs\Util\Utilities
    {
        return InstanceManager::getInstance()->getService('libUtilities');
    }

    /**
     * @return Session
     * @throws Exception
     */
    public static function getSession(): Session
    {
        return InstanceManager::getInstance()->getService('session');
    }
}
