<?php

namespace ACL\Repositories;


use ACL\Traits\TQuery;
use ACL\Helpers\Instances\InstanceProvider;
use Doctrine\ORM\EntityManager;

class Novocodigo extends RepositoryBase
{

    Use TQuery;

    protected $table = 'NOVOCODIGO';

    /** @var EntityManager */
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        parent::__construct($this->table);
        $this->entityManager = $entityManager;
    }

    /**
     * @param $nrorg
     * @param $tabela
     * @param $campo
     * @return array
     * @throws \Doctrine\DBAL\Exception
     */
    public function validateNovocodigo($nrorg, $tabela, $campo): array
    {
        $query = "SELECT $campo AS ID, NRSEQUENCIAL,
                         CASE WHEN $campo > TO_NUMBER(NRSEQUENCIAL)
                              THEN '1'
                              ELSE '2'
                          END AS VALIDACAO
                    FROM (SELECT MAX($campo) AS $campo
                            FROM (SELECT $campo
                                    FROM $tabela 
                                   WHERE REGEXP_LIKE($campo, '^[^a-zA-Z]*$')
                                     AND NRORG = :NRORG)),
                         (SELECT MAX(NRSEQUENCIAL) AS NRSEQUENCIAL
                            FROM NOVOCODIGO
                           WHERE CDCONTADOR = '$tabela'
                             AND NRORG = :NRORG)";

        $params = array(
            "NRORG" => $nrorg
        );

        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function updateNovocodigo($table, $newCode, $nrorg)
    {
        $query = "UPDATE NOVOCODIGO
                     SET NRSEQUENCIAL = :NEWCODE
                   WHERE CDCONTADOR = :CDCONTADOR
                     AND NRORG = :NRORG";

        $params = array(
            "NEWCODE"    => $newCode,
            "CDCONTADOR" => $table,
            "NRORG"      => $nrorg
        );

        try {
            $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
            $std->executeQuery($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
}
