CREATE OR REPLACE PROCEDURE CTB_DFE_DIFALIQUOTA(
   P_NRLANCTBTEMP IN LANCCONT.NRLANCCONT%TYPE,
   P_CDFILIAL IN FILIAL.CDFILIAL%TYPE,
   P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_FATOR IN INT,
   P_VRLANCTO IN OUT LANCCONT.VRLANCAMENT%TYPE)
AS
   V_COUNT INT;
   V_NRSEQLANC LANCCONT.NRSEQLANC%TYPE;
   V_DIFALIQ LANCCONT.VRLANCAMENT%TYPE;
   V_CDHISTPADR HISTPADR.CDHISTPADR%TYPE;
   V_DSHISTLANC LANCCONT.DSHISTLANC%TYPE;
   V_NUMPARTIDA INT;
   V_IDCOME VARCHAR2(01);
   V_IDCCUS VARCHAR2(01);
   V_CDCOMERCIAL FORNECEDOR.CDFORNECED%TYPE;
   V_CDCENTCUST CENTCUST.CDCENTCUST%TYPE;
   V_CDFILIAL FILIAL.CDFILIAL%TYPE;
   V_CONTCCUS VARCHAR2(01);
   V_ACUMULA VARCHAR2(01);

   PROCEDURE PARTIDAS(P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE,
                      P_CDCONTCTBL IN CONTCTBL.CDCONTCTBL%TYPE,
                      P_NRNOTAFISC IN NOTAFISCAL.NRNOTAFISC%TYPE,
                      P_IDORIGDESTNF IN NOTAFISCAL.IDORIGDESTNF%TYPE,
                      P_CDFORNECED IN FORNECEDOR.CDFORNECED%TYPE,
                      P_CDCLIENTE IN CLIENTE.CDCLIENTE%TYPE,
                      P_DTENTRSAID IN NOTAFISCAL.DTENTRSAID%TYPE,
                      P_VRIMPOSTOIT IN LANCCONT.VRLANCAMENT%TYPE,
                      P_CDFILIRECE IN FILIAL.CDFILIAL%TYPE)
   AS
   BEGIN
      /* PEGA O SEQUENCIAL DA ULTIMA PARTIDA DO LANCAMNENTO, O IF FOI UTILIZADO PARA NAO REALIZAR
         O SELECT NA TABELA DE LANAMENTO CONTBIL VRIAS VEZES. USADO SOMENTE PARA PEGAR O ULTIMO NUMERO
         DA PARTIDA DO LANCAMENTO CONTABIL, IDENTIFICADOR SE CONTROLA OS RATEIOS E SE O VALOR DA PARTIDA
         IR ACUMULAR */
      IF V_NUMPARTIDA IS NULL THEN
         /* NUMERO DA PARTIDA */
         BEGIN
            SELECT TO_NUMBER(MAX(NRSEQCTBTEMP))
              INTO V_NUMPARTIDA
              FROM LANCCTBTEMP
             WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
               AND CDEMPRESA = P_CDEMPRESA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NUMPARTIDA := 0;
         END;

         /* CONTROLA SE GERA OS RATEIOS - CONTROLA SE AS PARTIDAS ACUMULAM */
         SELECT IDCONTGERE, IDACUMVRCONT
           INTO V_CONTCCUS, V_ACUMULA
           FROM CONTOPECTBL
          WHERE CDEMPRESA = P_CDEMPRESA;
      END IF;

      /* BUSCA O CODIGO COMERCIAL */
      BEGIN
         SELECT DECODE(P_IDORIGDESTNF, 'F', P_CDFORNECED, DECODE(P_IDORIGDESTNF, 'C', P_CDCLIENTE, NULL))
           INTO V_CDCOMERCIAL
           FROM DUAL;
       EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDCOMERCIAL := NULL;
       END;

      BUSCA_TPCOMERCIAL(P_CDCONTCTBL, V_IDCOME, V_IDCCUS);

      IF V_ACUMULA = 'S' THEN
         BEGIN
            SELECT COUNT(*), NRSEQCTBTEMP
              INTO V_COUNT, V_NRSEQLANC
              FROM LANCCTBTEMP
             WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
               AND CDEMPRESA = P_CDEMPRESA
               AND CDCONTCTBL = P_CDCONTCTBL
               AND CDLANCCTBCOME = V_CDCOMERCIAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_COUNT := 0;
               V_NRSEQLANC := NULL;
         END;
         IF V_COUNT = 0 THEN
            V_NUMPARTIDA := V_NUMPARTIDA + 1;
            INSERT INTO LANCCTBTEMP
               (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
            VALUES
               (P_CDEMPRESA, P_NRLANCTBTEMP, P_NRNOTAFISC, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), P_CDCONTCTBL, V_CDHISTPADR,
               V_DSHISTLANC, P_DTENTRSAID, P_VRIMPOSTOIT * P_FATOR, V_IDCOME, V_CDCOMERCIAL, 'DFE');
            IF V_CONTCCUS <> 'N' THEN
               IF V_IDCCUS <> 'O' THEN
                  V_CDCENTCUST := BUSCA_CCUSTO(V_CDFILIAL, P_CDEMPRESA);
                  INSERT INTO RATECTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                  VALUES
                     (P_CDEMPRESA, P_NRLANCTBTEMP, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), P_CDFILIRECE,
                     V_CDCENTCUST, P_VRIMPOSTOIT * P_FATOR, P_DTENTRSAID, '00001');
               END IF;
            END IF;
         ELSE
            UPDATE LANCCTBTEMP
               SET VRLANCCTBTEMP = VRLANCCTBTEMP + (P_VRIMPOSTOIT * P_FATOR)
             WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
               AND CDEMPRESA = P_CDEMPRESA
               AND NRSEQCTBTEMP = V_NRSEQLANC;

            V_CDCENTCUST := BUSCA_CCUSTO(V_CDFILIAL, P_CDEMPRESA);

            UPDATE RATECTBTEMP
               SET VRRATECTBTEMP = VRRATECTBTEMP + P_VRIMPOSTOIT * P_FATOR
             WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
               AND CDEMPRESA = P_CDEMPRESA
               AND NRSEQCTBTEMP = V_NRSEQLANC
               AND CDFILIAL = P_CDFILIRECE
               AND CDCENTCUST = V_CDCENTCUST;
         END IF;
      ELSE
         V_NUMPARTIDA := V_NUMPARTIDA + 1;
         INSERT INTO LANCCTBTEMP
            (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
             DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
         VALUES
            (P_CDEMPRESA, P_NRLANCTBTEMP, P_NRNOTAFISC, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), P_CDCONTCTBL, V_CDHISTPADR,
             V_DSHISTLANC, P_DTENTRSAID, P_VRIMPOSTOIT * P_FATOR, V_IDCOME, V_CDCOMERCIAL, 'DFE');

         IF V_CONTCCUS <> 'N' THEN
            IF V_IDCCUS <> 'O' THEN
               V_CDCENTCUST := BUSCA_CCUSTO(V_CDFILIAL, P_CDEMPRESA);
               INSERT INTO RATECTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
               VALUES
                  (P_CDEMPRESA, P_NRLANCTBTEMP, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), P_CDFILIRECE,
                  V_CDCENTCUST, P_VRIMPOSTOIT * P_FATOR, P_DTENTRSAID, '00001');
            END IF;
         END IF;
      END IF;
   END;
BEGIN
   V_DIFALIQ := 0;
   V_NUMPARTIDA := NULL;
   /* BUSCA O HISTORICO PARA O LANCAMENTO */
   CTB_DFE_HISTORICO(P_CDFILIAL, P_NRLANCTONF, V_CDHISTPADR, V_DSHISTLANC);

   /* ROTINA DE CONTABILIZAO DOS DIFERENCIAIS DE ALIQUOTA QUE COMPOEM O VALOR DO PRODUTO */
   FOR DIFALIQ IN
    (SELECT ROUND(IMP.VRIMPOSTOIT, 2) VRIMPOSTOIT,
            CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCCTBLPASS,
            NF.CDEMPRESA, NF.NRNOTAFISC, NF.DTENTRSAID, NF.CDCLIENTE, NF.CDFORNECED,
            NF.IDORIGDESTNF, NF.CDFILIRECE
       FROM NOTAFISCAL NF, ITEMPROIMPOS IMP, ITEMPRODUTO IT, IMPOSTO I
      WHERE IMP.CDFILIAL    = P_CDFILIAL      AND
            IMP.NRLANCTONF  = P_NRLANCTONF    AND
            IMP.CDFILIAL    = NF.CDFILIAL    AND
            IMP.NRLANCTONF  = NF.NRLANCTONF  AND
            IMP.NRSEQITPROD = IT.NRSEQITPROD AND
            IMP.NRLANCTONF  = IT.NRLANCTONF  AND
            IMP.CDFILIAL    = IT.CDFILIAL    AND
            IMP.CDIMPOSTO   = I.CDIMPOSTO    AND
            IMP.CDFISCALIT  IN ('2', '3')    AND
            I.IDTIPCONTAB   = 'D'            AND
            IDIMPORECUP     = 'S'            AND
            IDDIFALIQCUSPRI = 'S') LOOP

       V_DIFALIQ := V_DIFALIQ + ROUND(DIFALIQ.VRIMPOSTOIT, 2);
       PARTIDAS(DIFALIQ.CDEMPRESA, DIFALIQ.CDCCTBLPASS, DIFALIQ.NRNOTAFISC,
                DIFALIQ.IDORIGDESTNF, DIFALIQ.CDFORNECED, DIFALIQ.CDCLIENTE,
                DIFALIQ.DTENTRSAID,  DIFALIQ.VRIMPOSTOIT, DIFALIQ.CDFILIRECE);
   END LOOP;

   FOR DIFALIQ IN /* DIFERENCIAIS DE ALIQUOTA QUE NO COMPOEM O CUSTO DO PRODUTO NO ESTOQUE */
      (SELECT ROUND(IMP.VRIMPOSTOIT, 2) VRIMPOSTOIT,
              CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCCTBLPASS,
              CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCCTBLDESP,
              NF.CDEMPRESA, NF.NRNOTAFISC, NF.DTENTRSAID, NF.CDCLIENTE, NF.CDFORNECED,
              NF.IDORIGDESTNF, NF.CDFILIRECE
         FROM NOTAFISCAL NF, ITEMPROIMPOS IMP, ITEMPRODUTO IT, IMPOSTO I
        WHERE IMP.CDFILIAL    = P_CDFILIAL      AND
              IMP.NRLANCTONF  = P_NRLANCTONF    AND
              IMP.CDFILIAL    = NF.CDFILIAL    AND
              IMP.NRLANCTONF  = NF.NRLANCTONF  AND
              IMP.NRSEQITPROD = IT.NRSEQITPROD AND
              IMP.NRLANCTONF  = IT.NRLANCTONF  AND
              IMP.CDFILIAL    = IT.CDFILIAL    AND
              IMP.CDIMPOSTO   = I.CDIMPOSTO    AND
              IMP.CDFISCALIT  IN ('2', '3')    AND
              IMP.NRITPROIMPOS = '3'           AND
              I.IDTIPCONTAB   = 'D'            AND
              IDIMPORECUP     = 'S'            AND
              IDDIFALIQCUSPRI = 'N')LOOP
       PARTIDAS(DIFALIQ.CDEMPRESA, DIFALIQ.CDCCTBLPASS, DIFALIQ.NRNOTAFISC,
                DIFALIQ.IDORIGDESTNF, DIFALIQ.CDFORNECED, DIFALIQ.CDCLIENTE,
                DIFALIQ.DTENTRSAID,  DIFALIQ.VRIMPOSTOIT, DIFALIQ.CDFILIRECE);
   END LOOP;

   P_VRLANCTO := P_VRLANCTO + V_DIFALIQ;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('CTB_DFE_DIFALIQUOTA','5.50.000'); END;
/


