import { Singleton } from '@zeedhi/core';
import { Modal, ModalService } from '@zeedhi/common';

@Singleton
export class AclTestController {
	private testModal!: Modal;

	public async createTestModal() {
		this.testModal = await ModalService.createFromJson('components/test/modal/modal', true);
	}

	public destroyTesteModal() {
		this.testModal?.destroy();
	}

	public openTestModal() {
		this.testModal.show();
	}

	public closeTestModal() {
		this.testModal.hide();
	}

	public buttonClick() {
		console.log('click');
	}
}
